<script lang="ts">
  import type { Route, Policy } from '$lib';
  import { routes, policies, successMessage, errorMessage } from '$lib/stores';
  import Sidebar from '$lib/Sidebar.svelte';
  import SuccessMessage from '$lib/SuccessMessage.svelte';
  import ErrorMessage from '$lib/ErrorMessage.svelte';
  import Modal from '$lib/Modal.svelte';
  import Dropdown from '$lib/Dropdown.svelte';

  let showModal = false;

  // Reset success and error messages on page load
  successMessage.set('');
  errorMessage.set('');

  const policyChoices = [
    { value: '', label: 'Nieuwe policy' },
    ...$policies.map((policy) => ({
      value: policy.id.toString(),
      label: policy.name,
    })),
  ];

  const newRoute: Route & {
    policyIdString: string;
  } = {
    method: 'GET',
    path: '',
    policyId: undefined,
    policyIdString: '',
  };

  // modalRoute is used to keep track of the currently active route while the modal is open. Note: we copy by value instead of by reference
  let modalRoute = { ...newRoute };

  // modalRouteIndex is used to keep track of whether the user is adding a new route or editing an existing route (and which one)
  let modalRouteIndex: number | undefined;

  function formatPath(input: string): string {
    return input.replace(/(\\*)(\*)/g, (_, escapes, star) => {
      // If the number of backslashes before * is even, it's not escaped
      if (escapes.length % 2 === 0) {
        // Encapsulate * in a span
        return `${escapes.slice(0, escapes.length / 2)}<span class="wildcard">${star}</span>`;
      } else {
        // If the number of backslashes before * is odd, it's escaped
        // In this case, remove one backslash and keep the *
        return escapes.slice(0, (escapes.length - 1) / 2) + star;
      }
    });
  }

  function upsertRoute(): void {
    // If 'New policy' is selected, create a new empty policy
    if (modalRoute.policyIdString === '') {
      let policy: Policy = { id: 1, name: `Nieuwe policy voor ${modalRoute.path}`, rules: [] };

      policies.update((items) => {
        // Give the policy a unique ID and push it to the list of policies
        while (items.findIndex((item) => item.id === policy.id) !== -1) {
          policy.id++;
        }
        items.push(policy);

        modalRoute.policyId = policy.id;
        modalRoute.policyIdString = policy.id.toString();

        return items;
      });
    }

    // Upsert the route
    const routeWithPolicy = { ...modalRoute, policyId: parseInt(modalRoute.policyIdString, 10) };
    if (modalRouteIndex === undefined) {
      routes.update((values) => [...values, routeWithPolicy]);
    } else {
      routes.update((values) => [
        ...values.slice(0, modalRouteIndex),
        routeWithPolicy,
        ...values.slice((modalRouteIndex || 0) + 1),
      ]);
    }

    showModal = false;
  }
</script>

<svelte:head>
  <title>Routes — FSC Policy Builder</title>
</svelte:head>

<div class="grid min-h-screen grid-cols-12">
  <Sidebar active="routes" />

  <div class="col-span-7 bg-slate-50 p-6 sm:col-span-8 lg:col-span-9">
    <h1 class="mb-5 text-2xl font-medium">Routes</h1>

    {#if $errorMessage}
      <ErrorMessage bind:message={$errorMessage} />
    {:else if $successMessage}
      <SuccessMessage bind:message={$successMessage} />
    {/if}

    <p class="mb-7">
      <button
        on:click={() => {
          modalRoute = { ...newRoute };
          modalRouteIndex = undefined;
          showModal = true;
        }}
        type="button"
        class="inline-flex items-center rounded-lg border border-indigo-600 bg-indigo-500 px-3 py-2 text-sm font-medium text-white shadow-sm hover:border-indigo-700 hover:bg-indigo-600 focus:outline-none focus:ring-4 focus:ring-indigo-200"
      >
        <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
          <path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M12 5v14m-7-7h14"
          />
        </svg>
        Voeg een route toe
      </button>
    </p>

    <div class="relative overflow-x-auto rounded-md border border-slate-200 bg-white px-5 pt-1">
      <table class="w-full text-left">
        <thead class="text-sm">
          <tr>
            <th scope="col" class="py-3 font-semibold">Methode</th>
            <th scope="col" class="py-3 font-semibold">Pad</th>
            <th scope="col" class="py-3 font-semibold">Policy</th>
            <th scope="col" class="py-3 font-semibold">Acties</th>
          </tr>
        </thead>
        <tbody>
          {#each $routes as route, i (i)}
            {@const policy = $policies.find((policy) => policy.id === route.policyId)}
            <tr class="border-t border-slate-200">
              <td class="py-4">
                <span
                  class="rounded px-2 py-1 text-sm font-semibold text-white"
                  class:bg-blue-500={route.method === 'GET'}
                  class:bg-emerald-500={route.method === 'POST'}
                  class:bg-amber-500={route.method === 'PUT'}
                  class:bg-rose-500={route.method === 'DELETE'}
                  class:bg-teal-500={route.method === 'PATCH'}
                  class:bg-violet-500={route.method === 'HEAD'}
                  class:bg-cyan-500={route.method === 'OPTIONS'}
                  class:bg-slate-500={route.method === 'TRACE' || route.method === 'CONNECT'}
                  class:bg-indigo-500={route.method === 'ANY'}>{route.method}</span
                >
              </td>
              <td class="py-4 font-mono">
                {@html formatPath(route.path)}
              </td>
              <td class="py-4">
                {#if policy}
                  <a
                    class="font-mono text-sm text-blue-700 hover:underline"
                    href="/policies/{policy.id}">{policy.name}</a
                  >
                {:else}
                  Geen policy
                {/if}
              </td>
              <td class="py-4">
                <button
                  on:click={() => {
                    modalRoute = {
                      ...route,
                      policyIdString: route.policyId ? route.policyId.toString() : '',
                    };
                    modalRouteIndex = i;
                    showModal = true;
                  }}
                  type="button"
                  class="text-slate-500 hover:text-indigo-700"
                >
                  <svg class="h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
                    ><path
                      fill="none"
                      stroke="currentColor"
                      stroke-linecap="round"
                      stroke-linejoin="round"
                      stroke-width="2"
                      d="M4 20h4L18.5 9.5a2.828 2.828 0 1 0-4-4L4 16zm9.5-13.5l4 4"
                    /></svg
                  >
                </button>
                <button
                  on:click={() => {
                    if (confirm('Weet je zeker dat je deze route wilt verwijderen?')) {
                      routes.update((values) => values.filter((_, index) => index !== i));
                    }
                  }}
                  type="button"
                  class="text-slate-500 hover:text-rose-700"
                >
                  <svg class="h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
                    ><path
                      fill="none"
                      stroke="currentColor"
                      stroke-linecap="round"
                      stroke-linejoin="round"
                      stroke-width="2"
                      d="M4 7h16m-10 4v6m4-6v6M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2l1-12M9 7V4a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v3"
                    /></svg
                  >
                </button>
              </td>
            </tr>
          {:else}
            <tr class="border-t border-slate-200">
              <td class="py-4 text-center text-gray-600" colspan="4">
                Nog geen routes gevonden.
              </td>
            </tr>
          {/each}
        </tbody>
      </table>
    </div>
  </div>
</div>

<Modal bind:showModal>
  <h2 slot="header" class="mb-5 border-b border-slate-200 pb-4 text-2xl font-medium">
    {#if modalRouteIndex === undefined}
      Route toevoegen
    {:else}
      Route aanpassen
    {/if}
  </h2>

  <div class="grid grid-cols-3">
    <label
      class="col-span-3 break-words py-2 font-medium text-gray-600 sm:col-span-1 sm:mb-5 sm:pr-2"
      for="method">HTTP-methode</label
    >
    <div class="col-span-3 mb-7 grid gap-1 pt-2.5 sm:col-span-2 sm:grid-cols-3">
      {#each [{ value: 'GET', label: 'GET', color: 'blue' }, { value: 'POST', label: 'POST', color: 'emerald' }, { value: 'PUT', label: 'PUT', color: 'amber' }, { value: 'DELETE', label: 'DELETE', color: 'rose' }, { value: 'PATCH', label: 'PATCH', color: 'teal' }, { value: 'HEAD', label: 'HEAD', color: 'violet' }, { value: 'OPTIONS', label: 'OPTIONS', color: 'cyan' }, { value: 'TRACE', label: 'TRACE', color: 'slate' }, { value: 'CONNECT', label: 'CONNECT', color: 'slate' }, { value: 'ANY', label: 'Elke methode', color: 'indigo' }] as item}
        <label class="inline-flex items-center">
          <input
            class="form-radio mr-2 border-{item.color}-300 bg-white text-{item.color}-600 focus:ring-indigo-500"
            type="radio"
            bind:group={modalRoute.method}
            value={item.value}
          />
          {item.label}
        </label>
      {/each}
    </div>

    <label
      class="col-span-3 break-words py-2 font-medium text-gray-600 sm:col-span-1 sm:mb-5 sm:pr-2"
      for="path">Pad</label
    >
    <div class="col-span-3 mb-7 sm:col-span-2">
      <input
        bind:value={modalRoute.path}
        type="text"
        id="path"
        class="block w-full rounded-lg border border-gray-300 p-2.5 font-mono text-sm text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
        placeholder="Voorbeeld: /books/*"
        autocomplete="off"
      />
    </div>

    <label
      class="col-span-3 break-words py-2 font-medium text-gray-600 sm:col-span-1 sm:mb-5 sm:pr-2"
      for="policy">Policy</label
    >
    <div class="col-span-3 mb-12 sm:col-span-2">
      <Dropdown
        bind:value={modalRoute.policyIdString}
        id="policy"
        options={policyChoices}
        color={modalRoute.policyIdString === '' ? 'slate' : 'blue'}
      />
    </div>
  </div>

  <div slot="footer" class="border-t border-slate-200 pt-7">
    <button
      on:click={upsertRoute}
      type="button"
      class="mr-1 inline-block rounded-lg border border-indigo-600 bg-indigo-500 px-3 py-2 font-medium text-white shadow-sm hover:border-indigo-700 hover:bg-indigo-600 focus:outline-none focus:ring-4 focus:ring-indigo-200"
    >
      Opslaan
    </button>
    <button
      on:click={() => {
        showModal = false;
      }}
      type="button"
      class="inline-block rounded-lg border border-indigo-300 bg-white px-3 py-2 font-medium text-indigo-800 shadow-sm hover:border-indigo-300 hover:bg-indigo-100 hover:text-indigo-900 focus:outline-none focus:ring-4 focus:ring-indigo-100"
    >
      Annuleren
    </button>
  </div>
</Modal>

<style lang="postcss">
  :global(.wildcard) {
    @apply rounded bg-indigo-100 px-1 py-0.5 text-indigo-950;
  }
</style>
